"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var proppy_1 = require("proppy");
function attach(ProppyFactory) {
    return function (Component) {
        var componentPropNames = Component.props || [];
        var watch = componentPropNames.reduce(function (acc, propName) {
            acc[propName] = function (newVal, oldVal) {
                var _a;
                if (typeof newVal !== 'undefined') {
                    this._parent.set((_a = {},
                        _a[propName] = newVal,
                        _a));
                }
            };
            return acc;
        }, {});
        return {
            name: "Attached" + Component.name,
            inject: ['proppy'],
            props: componentPropNames,
            watch: watch,
            data: function () {
                return {
                    proppyProps: {}
                };
            },
            methods: {
                setProppyProps: function (props) {
                    this.proppyProps = Object.assign({}, props);
                }
            },
            beforeMount: function () {
                var _this = this;
                var parentProps = componentPropNames.reduce(function (acc, componentPropName) {
                    var _a;
                    if (typeof _this[componentPropName] === 'undefined') {
                        return acc;
                    }
                    return __assign({}, acc, (_a = {}, _a[componentPropName] = _this[componentPropName], _a));
                }, {});
                this._parent = proppy_1.create({
                    initialize: function () {
                        this.set(parentProps);
                    }
                })(this.proppy || {});
                this._p = ProppyFactory(this.proppy, this._parent);
                this.setProppyProps(this._p.props);
                this._p.subscribe(function (props) {
                    _this.setProppyProps(props);
                });
            },
            beforeDestroy: function () {
                if (this._p) {
                    this._p.destroy();
                }
            },
            render: function (h) {
                var data = {
                    props: this.proppyProps
                };
                return h(Component, data);
            },
        };
    };
}
exports.attach = attach;
//# sourceMappingURL=attach.js.map